#!/bin/sh

PATH=/usr/bin:/bin
export PATH

genscript()
{
cat > tmp.vbs <<EOF
cygwintop = "$1"
name = "$2.lnk"
args = "$3"
Set shell = WScript.CreateObject("WScript.Shell")
Set shortcut = shell.CreateShortcut(shell.SpecialFolders("Desktop") + "\" + name)
shortcut.TargetPath = cygwintop + "\bin\ckstartup.js"
shortcut.WorkingDirectory = cygwintop + "\bin"
shortcut.Arguments = args
shortcut.WindowStyle = 0
EOF
case "$4" in
"")
  ;;
*)
  cat >> tmp.vbs <<EOF
shortcut.IconLocation = "$4"
EOF
  ;;
esac
cat >> tmp.vbs <<EOF
shortcut.Save
EOF
}

# icon and binaries
cp files/gnu.ico /
cp files/*.exe /bin
cp files/*.js /bin

# ck, emacs
path=`cygpath -S`/cscript
cygwintop="`cygpath -aw /`"
genscript "${cygwintop}" "ck" "-e bash --login" "${cygwintop}\\bin\ck.exe"
"$path" tmp.vbs > /dev/null
genscript "${cygwintop}" "emacs" "-title Emacs -e bash --login -c emacs" "${cygwintop}\\gnu.ico"
"$path" tmp.vbs > /dev/null
rm tmp.vbs

# cyg-emacs-client
path=`cygpath -u "$USERPROFILE/SendTo/"`
rm -f "$path/Emacs" "$path/Emacs.lnk"
ln -s /bin/cyg-emacsclient.exe "$path/Emacs"

# emacs-el
tar Cxzfp / files/emacs-el-modified.tgz

# .emacs.el and .Xdefaults
d=`date +'%Y%m%d-%H%M%S'`
for i in Xdefaults emacs.el
do
  if [ -f "$HOME/.$i" -o -d "$HOME/.$i" ]; then
    echo -n "replace $HOME/.$i (y/n)? "
    read answer
    case $answer in
    y)
      backup="$HOME/.$i.$d"
      echo "moving last $HOME/.$i to $backup"
      mv $HOME/.$i $backup
      ;;
    *)
      continue
      ;;
    esac
  fi
  rm -rf "$HOME/.$i"
  cp -r "files/_$i" "$HOME/.$i"
done
